/*
 * jQuery Slideshow Plugin for WYSIWYG Web Builder v9.x
 * Copyright Pablo Software solutions 2012
 * http://www.wysiwygwebbuilder.com/
 */

(function($)
{
   $.fn.cms_slideshow = function(options) 
   {
      return this.each(function() 
      {   
         $.cms_slideshow(this, options);
      });
   };

   $.cms_slideshow = function(container, options) 
   {
      var settings = 
      {
         effect: 'none',
         effectlength: 2000,
         direction: '',
         interval: 2000,
         type: 'sequence',
         current: 1,
         last: 0
      };

      if (options)
         state = $.extend(settings, options);

      $.cms_slideshow.init(container, state); 
   };

   $.cms_slideshow.init = function(container, state)
   {
      state.images = $(container).find('img').get();
      $.each(state.images, function(i)
      {
         $(state.images[i]).css('zIndex', state.images.length - i).css('position', 'absolute').css('top', '0').css('left', '0');
      });
  
      $(container).data('state', state);

      var interval = state.interval;
      if (state.effect == 'kenburns') 
      {
         interval = 1;
      }
      if (interval != 0)
      {
         setTimeout(function()
         {
            $.cms_slideshow.imagetransition(container);
         }, interval);
      }
   };

   $.cms_slideshow.next = function(state)
   {
      if (state.type == 'sequence') 
      {
         if (( state.current + 1 ) < state.images.length) 
         {
            state.current = state.current + 1;
            state.last = state.current - 1;
         }
         else 
         {
            state.current = 0;
            state.last = state.images.length - 1;
         }
      }
      else 
      if (state.type == 'random') 
      {
         state.last = state.current;
         while (state.current == state.last) 
         {
            state.current = Math.floor(Math.random() * (state.images.length));
         }
      }
   };
 	
   $.cms_slideshow.imagetransition = function(container)
   {
         state = $(container).data('state');

         for (var i = 0; i < state.images.length; i++) 
         {
            $(state.images[i]).css('display', 'none');
         }
         $(state.images[state.last]).css('display', 'block').css('zIndex', '0');

         if (state.effect == 'none') 
         {
	    $(state.images[state.current]).css('zIndex', '1').show();
            $(state.images[state.last]).css('display', 'none');
         }
         else
         if (state.effect == 'fade') 
         {
            $(state.images[state.current]).css('zIndex', '1').fadeIn(state.effectlength);
         }
         else
         if (state.effect == 'slide') 
         {
            $(state.images[state.current]).css('zIndex', '1').show('slide', { direction: state.direction }, state.effectlength);
         }
         else
         {
            $(state.images[state.current]).css('zIndex', '1').show(state.effect, { }, state.effectlength);
         } 

         if (state.interval != 0)
         {       
            $.cms_slideshow.next(state);   

            setTimeout(function()
            {
               $.cms_slideshow.imagetransition(container);
            }, state.interval);
         }
   };
 
})(jQuery);